package edu.ucf.rp2;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

public class CSVWriter 
{
	private String fileName;
	private BufferedWriter writer;
	private String crntLine;
	
	
	public CSVWriter (String fileName){
		this.fileName = fileName;
		newWriter();
	}
	
	
	public void nextField (String input) {
		if (crntLine==null) {
			crntLine = "\"" + input + "\"";
		} else {
			crntLine = crntLine + "," + "\"" + input + "\"";
		}
	}
	
	
	public void writeLine ()
	{
		try {
			writer.write(crntLine + "\n");
		} catch (IOException e1) {
			close();
			newWriter();
			
			try {
				writer.write(crntLine + "\n");
			} catch (IOException e2) {
				e2.printStackTrace();
			}
		} finally {
			crntLine = null;
		}
	}
	
	
	public void close ()
	{
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	private void newWriter ()
	{
		String timeStamp = 
				new SimpleDateFormat("yyyyMMdd_HHmm").format(Calendar.getInstance().getTime());
		
		try {
			writer = new BufferedWriter(new FileWriter (fileName + "_" + timeStamp + ".csv"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	
	public void writeNext (String[] input) {
		String csvLine = toCSVLine(input);
		
		try {
			writer.write(csvLine);
		} catch (IOException e) {
			close();
			newWriter();
			try {
				writer.write(csvLine);
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	private String toCSVLine (String[] input)
	{
		String csvLine = "";
		
		if (input.length == 0) { return csvLine; }
		
		for (String token : input)
		{
			csvLine = csvLine + token + ",";
		}
		
		return csvLine + "\n";
	}
	

}
