package edu.ucf.rp2;

import java.util.List;


public class GoogleTester extends Tester 
{

	
	public GoogleTester () {
		this.logName = "Google";
		this.maxSampleSize = Integer.MAX_VALUE;
	}
	
	
	public GoogleTester (String logName) {
		this.logName = logName;
		this.maxSampleSize = Integer.MAX_VALUE;
	}
	
	
	public GoogleTester (String logName, int maxSampleSize) {
		this.logName = logName;
		this.maxSampleSize = maxSampleSize;
	}
	
	
	protected void processSearch (String searchTerm) {
		GoogleSearch search = new GoogleSearch(searchTerm);
		List<GoogleAd> ads = search.ads();
		
		for (GoogleAd ad : ads)
			processAd(ad);
	}
	
	
	protected void processAd (GoogleAd ad) {
		logger.nextField(Integer.toString(linkID++));
		logger.nextField(ad.getClickTrackURL());
		logger.nextField(ad.getDestURL());
		
		compareWebsites(ad.getClickTrackURL(), ad.getDestURL());
		
		logger.nextField(Integer.toString(ad.sec1Length()));
		logger.nextField(Integer.toString(ad.numAmps()));
		for (String sec3Parameter : ad.sec3Parameters())
			logger.nextField(sec3Parameter);
		logger.writeLine();
		
		processEncodedChars(ad.encodedChars());
	}
	
	
	protected void makeHeader() {
		logger.nextField("Key");
		logger.nextField("GoogleURL");
		logger.nextField("DestURL");
		logger.nextField("GoogleCode");
		logger.nextField("DestCode");
		logger.nextField("Diff");
		logger.nextField("Sec1Length");
		logger.nextField("NumAmps");
		logger.nextField("Parameters");
		logger.writeLine();
	}
	
	
}
