package edu.ucf.rp2;

import java.util.ArrayList;
import java.util.List;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;


public class YahooSearch {
	
	
	private String searchUrl;
	private String searchSource;
	
	
	public YahooSearch (String phrase) {
		searchUrl = "http://search.yahoo.com/search?q=" + phrase.replaceAll(" ", "+");
		fetchSearchSource();
	}
	
	/**
	 * Retrieves the source code of a SERP
	 */
	private void fetchSearchSource () {
		WebFetcher wb = new WebFetcher(searchUrl);
		wb.exec();
		searchSource = wb.getSource();
	}
	
	/**
	 * Returns a list of all ads in a SERP
	 * @return list of all ads in a SERP
	 */
	public List<YahooAd> ads () {
		List<YahooAd> ads = new ArrayList<YahooAd>();
		
		Elements rawAds = adsHTML();
		
		for (Element rawAd : rawAds)
		{
			String bingURL = rawAd.attr("href");
			YahooAd YahooAd = new YahooAd(bingURL);
			ads.add(YahooAd);
		}
		
		return ads;
	}
	
	/**
	 * Returns the SERP source code
	 * @return SERP source code
	 */	
	public String getsearchSource () {
		return searchSource;
	}
	
	/**
	 * Extracts the ad HTML elements from the search source
	 * @return ad HTML elements
	 */
	private Elements adsHTML () {
		Elements yahooElements = new Elements();
		
		Document document = Jsoup.parse(searchSource);
		Elements anchors = document.getElementsByTag("a");
		
		for (Element anchor : anchors)
		{
			if (anchor.attr("href").indexOf("%26u=")!=-1) 
			{
				yahooElements.add(anchor);
			}
		}
		
		return yahooElements;
	}	
	
}
